function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

/* eslint no-use-before-define:0 */

/**
 * Convert the input from its source type into its actual type
 * @param input
 */
export default function normalify(input) {
  var result = normalifyObject(input);
  if (result !== input) return result;
  return normalifyString(input);
}
/**
 * Convert the input object and its nested values into their actual types
 * @param input
 */

export function normalifyObject(input) {
  if (_typeof(input) === 'object') {
    for (var key in input) {
      if (input.hasOwnProperty(key)) {
        var value = input[key];
        var result = normalify(value); // http://jsperf.com/pre-check

        if (result !== value) {
          input[key] = result;
        }
      }
    }
  }

  return input;
}
/**
 * Convert the input from its source type into its actual type
 * @param input
 */

export function normalifyString(input) {
  if (typeof input === 'string') {
    if (input === 'NaN' || input === '"NaN"' || input === "'NaN'") {
      return NaN;
    }

    try {
      if (input.startsWith("'") && input.endsWith("'")) {
        input = '"' + input.slice(1, -1) + '"';
      }

      var result = JSON.parse(input);

      if (result !== input) {
        return normalify(result);
      }

      return result;
    } catch (err) {
      return input;
    }
  } else {
    return input;
  }
}